/*
 * ***** BEGIN LICENSE BLOCK *****
 *   Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is GTDInbox.
 *
 * The Initial Developer of the Original Code is
 * Andy Mitchell (andy@gtdinbox.com)
 * Portions created by the Initial Developer are Copyright (C) 2009
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * 
 * ***** END LICENSE BLOCK ***** */


/**
 * 
 *
 * @class ? @extends gtdUIObject
 */
var gtdChangePassword = gtdUIObject.extend({
    // Properties {
        	
    /** @property {private glEventsContainer} ? Collection of manageable events on DOM elements */
    _eventsContainer: null,
    
    /** @property {private gtdMainPagePlugin} ? The main gtd plugin for this page */
    _gtd: null,
    
    /** @property {Element} ? The main box */
    el: null,
    	
    //}

    // Methods {
    /**
     * Connects the element to the given gtdMainPagePlugin object's page. Called
     * automatically by {@link gtdMainPagePlugin.getUIObject}.
     * @function ?
     * @param {gtdMainPagePlugin} gtd - The gtdMainPagePlugin object for the page
     */
    connect: function(gtd) {
        glLogger.log('Connecting gtdChangePassword object to view', 'gtdChangePassword');

        this.base(gtd);
        this._gtd = gtd;
	this._eventsContainer = new glEventsContainer(this);

	var doc = gtd.gmail.canvasDocument;
        
        this.el = doc.createElement("DIV");
	
	var elP1 = doc.createElement("DIV");
	elP1.className = "p1";
	//elP1
    },
    
    

    /**
     * Called on page shutdown, it does cleanup
     * @function ?
     */
    disconnect: function() {
        glLogger.log('Disconnecting gtdComposePersonal from view', 'gtdComposePersonal');

        this._eventsContainer.reset();
        
        if( this.el ) this.el.parentNode.removeChild( this.el );
		this.el = null;
        this.base();
    },
    //}
},{
    
    /**
     * Notification that user has updated their password
     * @event
     */
    TRY_AGAIN: 'try_again',
    
    /**
     * Notification that the change password process was cancelled.
     * @event
     */
    CANCEL: 'cancel',
});
gtdChangePassword.implement(glEventDispatcher); // Add event dispatching support