/*
 * ***** BEGIN LICENSE BLOCK *****
 *   Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is GTDInbox.
 *
 * The Initial Developer of the Original Code is
 * Andy Mitchell (andy@gtdinbox.com)
 * Portions created by the Initial Developer are Copyright (C) 2009
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * 
 * ***** END LICENSE BLOCK ***** */


/**
 * Add Labels to Compose view when connected
 *
 * @class ? @extends gtdUIObject
 */
var gtdConversationLabels = gtdUIObject.extend({
    // Properties {
    
	/** @property {private gtdMainPagePlugin} ? The main gtd plugin for this page */
	_gtd: null,
	
	/** @property {Element} ? The tab container */
	el: null,
	
    //}

    // Methods {
    /**
     * Connects the element to the given gtdMainPagePlugin object's page. Called
     * automatically by {@link gtdMainPagePlugin.getUIObject}.
     * @function ?
     * @param {gtdMainPagePlugin} gtd - The gtdMainPagePlugin object for the page
     */
    connect: function(gtd) {
        glLogger.log('Connecting gtdConversationLabels object to view', 'gtdConversationLabels');

        this.base(gtd);
	this._gtd = gtd;
	
	var doc = gtd.gmail.canvasDocument;
	
	var gmailConversationView = gtd.gmail.getCurrentViewUIObject();
	
	this.el = doc.createElement("DIV");
		this.el.className = "conversation-header-labels";
	// TODO add Labels box here
	gmailConversationView.header.appendChild( this.el );
	

        //}
    },
    
	

    /**
     * Called on page shutdown, it does cleanup
     * @function ?
     */
    disconnect: function() {
        glLogger.log('Disconnecting gtdConversationLabels from view', 'gtdConversationLabels');

        this.base();
        
        if( this.el.parentNode ) this.el.parentNode.removeChild( this.el );
        this.el = null;
    },
    
    /**
     * Whether the UI object can be cached by {@link gtdMainPagePlugin.getUIObject}
     * @function {Boolean} ?
     * @return Whether the UI can be cached
     */
    isCacheable: function() {
        return false;
    },
    
    //}
});