/*
 * ***** BEGIN LICENSE BLOCK *****
 *   Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is GTDInbox.
 *
 * The Initial Developer of the Original Code is
 * Andy Mitchell (andy@gtdinbox.com)
 * Portions created by the Initial Developer are Copyright (C) 2009
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * 
 * ***** END LICENSE BLOCK ***** */


/**
 * 
 *
 * @class ? @extends gtdUIObject
 */
var gtdInstaller = gtdUIObject.extend({
    // Properties {
        	
    /** @property {private glEventsContainer} ? Collection of manageable events on DOM elements */
    _eventsContainer: null,
    
    /** @property {private gtdMainPagePlugin} ? The main gtd plugin for this page */
    _gtd: null,
    
    /** @property {Element} ? The Compose Personal shortcut */
    el: null,
	
    //}

    // Methods {
    /**
     * Connects the element to the given gtdMainPagePlugin object's page. Called
     * automatically by {@link gtdMainPagePlugin.getUIObject}.
     * @function ?
     * @param {gtdMainPagePlugin} gtd - The gtdMainPagePlugin object for the page
     */
    connect: function(gtd) {
        glLogger.log('Connecting gtdComposePersonal object to view', 'gtdComposePersonal');

        this.base(gtd);
        this._gtd = gtd;
	this._eventsContainer = new glEventsContainer(this);

	var doc = gtd.gmail.canvasDocument;
	
	var navBar = gtd.gmail.getUIObject("navBar");
	this.el = navBar.composeLink.cloneNode(true);
	this.el.innerHTML = glI18N.getString("Compose.Personal");
	navBar.composeLink.parentNode.appendChild( doc.createElement("BR") );
	navBar.composeLink.parentNode.appendChild( this.el );
	
	
	this._eventsContainer.observe( navBar.composeLink, "click", this._clickMail, false );
	this._eventsContainer.observe( this.el, "click", this._click, false );
	
	
        glLogger.log('Connected gtdComposePersonal object to view', 'gtdComposePersonal');
    },
    
    

    /**
     * Called on page shutdown, it does cleanup
     * @function ?
     */
    disconnect: function() {
        glLogger.log('Disconnecting gtdComposePersonal from view', 'gtdComposePersonal');

        this._eventsContainer.reset();
        
        if( this.el ) this.el.parentNode.removeChild( this.el );
		this.el = null;
        this.base();
    },
    //}
},{
    
});
gtdInstaller.implement(glEventDispatcher); // Add event dispatching support