/*
 * ***** BEGIN LICENSE BLOCK *****
 *   Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is GTDInbox.
 *
 * The Initial Developer of the Original Code is
 * Andy Mitchell (andy@gtdinbox.com)
 * Portions created by the Initial Developer are Copyright (C) 2009
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * 
 * ***** END LICENSE BLOCK ***** */


/**
 * The thread list view abstraction layer.
 *
 * @class ? @extends glUIView
 */
var gtdThreadListView = gtdUIObject.extend({
    // Properties {


		/** @property {private gtdMainPagePlugin} ? The main gtd plugin for this page */
		_gtd: null,

	/**
	* The {@link gtdActionsHeader} object for the view
	* @property {gtdActionsHeader} ?
	*/
	actionsHeader: null,
	
	/**
	* The {@link gtdThreadListCommands} object for the view
	* @property {gtdThreadListCommands} ?
	*/
	threadListCommands: null,
	
    //}

    // Methods {
    /**
     * Connects the element to the given glGmail object's page. Called automatically
     * by {@link glGmail.getUIObject}.
     * @function ?
     * @param {gtdMainPagePlugin} gtd - The gtdMainPagePlugin object for the page
     */
    connect: function(gtd) {
        glLogger.log('Connecting gtdThreadListView object to view', 'glThreadListView');

        this.base(gtd);
		this._gtd = gtd;
        this.actionsHeader = gtd.getUIObject('actionsHeader');
        
        this.threadListCommands = gtd.getUIObject('threadListCommands');

    },

    /**
     * Called on page shutdown, it does cleanup
     * @function ?
     */
    disconnect: function() {
        glLogger.log('Disconnecting gtdThreadListView from view', 'glThreadListView');
        
        this.actionsHeader.disconnect();
        this.actionsHeader = null;
        
        this.threadListCommands.disconnect();
        this.threadListCommands = null;
        this.base();
    },
    
    /**
     * Whether the UI object can be cached by {@link gtdMainPagePlugin.getUIObject}
     * @function {Boolean} ?
     * @return Whether the UI can be cached
     */
    isCacheable: function() {
        return false;
    },
    

    //}
});
